=== doc/sphinx/requirements.txt ===
sphinxcontrib-serializinghtml<1.1.6
sphinx<7.2
