=== debian/changelog ===
widelands (2:1.2.1-3) unstable; urgency=medium

  * Team upload.
  * Disable checking the local copy of the GPL versus the slightly edited
    one in base-files for the Trixie release (Closes: #1106308)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 30 May 2025 12:26:03 +0200

widelands (2:1.2.1-2) unstable; urgency=medium

  * Depends on fonts-culmus-fancy instead of the transition package
    culmus-fancy (Closes: #1069584).
  * Allow to build several times in a row by ignoring in d/s/options
    the files we remove during the initial cleaning to ensure that
    embeded libraries are not used (Closes: #1047250).

 -- Martin Quinson <mquinson@debian.org>  Mon, 23 Dec 2024 16:36:44 +0100

widelands (2:1.2.1-1) unstable; urgency=medium

  * New upstream release.
    From the announcement email: This point release fixes several bugs
    and crashes found in Widelands 1.2, and offers full compatibility
    between these two releases for multiplayer games and replays.
  * d/p/RelWithDebInfo: dropped (applied upstream).

 -- Martin Quinson <mquinson@debian.org>  Mon, 23 Dec 2024 00:13:10 +0100
