=== debian/watch ===
# test this watch file using:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package widelands
#
version=4
opts="uversionmangle=s/-rc/~rc/, \
      filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
https://github.com/widelands/widelands/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
